/*
 * QueenTest.java
 *
 * Created on 21. listopad 2006, 22:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package pa161.uloha_3;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author xmatena
 */
public class QueenTest {
    
    /**
     * Constructor for objects of class QueenTest
     */
    public QueenTest()  {
    }
    
    public static void main(String args[]) {
        
        boolean DEBUG = false;
        
        /*create situation*/
        ArrayList<Queen> game = new ArrayList<Queen>(8);
        
    /*  UHLOPRICKA  
        game.add(new Queen('a',8));
        game.add(new Queen('b',7));
        game.add(new Queen('c',6));
        game.add(new Queen('d',5));
        game.add(new Queen('e',4));
        game.add(new Queen('f',3));
        game.add(new Queen('g',2));
        game.add(new Queen('h',1));
    
        DOMACI ULOHA
    */
        game.add(new Queen('a',7));
        game.add(new Queen('e',8));
        game.add(new Queen('f',6));
        game.add(new Queen('d',5));
        game.add(new Queen('b',4));
        game.add(new Queen('g',3));
        game.add(new Queen('c',2));
        game.add(new Queen('h',1));
    
    /*  TOTO HEURISTIKA NEZVLADNE  
        
        game.add(new Queen('a',1));
        game.add(new Queen('e',8));
        game.add(new Queen('f',6));
        game.add(new Queen('d',4));
        game.add(new Queen('b',4));
        game.add(new Queen('g',3));
        game.add(new Queen('c',2));
        game.add(new Queen('h',7));
      */  
        System.out.println("\n------------------");
        for (Iterator k = game.iterator(); k.hasNext(); ) {
            System.out.print((Queen) k.next());
        }
        System.out.println();
        
        
        System.out.println("Pocet kolizi: " + performThreatenTest(game));
        
        ArrayList<Queen> bestGame = new ArrayList<Queen>(8);
        int bestScore = Integer.MAX_VALUE;
        int qScore;
        int score;
        Queen q;
        
        int moveCounter=0;
        
        int x;
        int y;
        boolean stop;
        
        while (performThreatenTest(game) != 0) {
            
            ArrayList<Queen> situation;
            for(Iterator it = game.iterator(); it.hasNext(); ) {
                q = (Queen) it.next();
                if (DEBUG) { System.out.print("Zpracujeme> " +q.toString() + "  "); }
                x = q.getX();
                y = q.getY();
                qScore = performThreatenTest(x,y,game);
                if (DEBUG) { System.out.println(qScore); }
                
                if (qScore > 0) {
                    /* make a situation without this queen */
                    situation = cloneExcept(q,game);
                    
                    if (DEBUG) {
                        System.out.print("Situace:");
                        for (Iterator k = situation.iterator(); k.hasNext(); ) {
                            System.out.print((Queen) k.next());
                        }
                        System.out.println();
                    }
                    
                    // right
                    if (DEBUG) {System.out.print(" R>");}
                    for (int xa = x+1; xa<'i' ;xa++) {
                        if (isLegalMove(xa,y,q,situation)) {
                            score = performThreatenTest(xa,y,situation);
                            if (DEBUG) {System.out.print(score);}
                            if (score < bestScore) {
                                bestScore = score;
                                bestGame.clear();
                                bestGame.addAll(situation);
                                bestGame.add(new Queen(xa,y));
                            }
                        } else {
                            break;
                        }
                    }
                    
                    // left
                    if (DEBUG) {System.out.print(" L>");}
                    for (int xa = x-1; xa >= 'a' ;xa--) {
                        if (isLegalMove(xa,y,q,situation)) {
                            score = performThreatenTest(xa,y,situation);
                            if (DEBUG) {System.out.print(score);}
                            if (score < bestScore) {
                                bestScore = score;
                                bestGame.clear();
                                bestGame.addAll(situation);
                                bestGame.add(new Queen(xa,y));
                            }
                        } else {
                            break;
                        }
                    }
                    
                    // up
                    if (DEBUG) {System.out.print(" U>");}
                    for (int ya = y+1; ya < 9 ;ya++) {
                        if (isLegalMove(x,ya,q,situation)) {
                            score = performThreatenTest(x,ya,situation);
                            if (DEBUG) {System.out.print(score);}
                            if (score < bestScore) {
                                bestScore = score;
                                bestGame.clear();
                                bestGame.addAll(situation);
                                bestGame.add(new Queen(x,ya));
                            }
                        } else {
                            break;
                        }
                    }
                    
                    // down
                    if (DEBUG) {System.out.print(" D>");}
                    for (int ya = y-1; ya > 0 ;ya--) {
                        if (isLegalMove(x,ya,q,situation)) {
                            score = performThreatenTest(x,ya,situation);
                            if (DEBUG) {System.out.print(score);}
                            if (score < bestScore) {
                                bestScore = score;
                                bestGame.clear();
                                bestGame.addAll(situation);
                                bestGame.add(new Queen(x,ya));
                            }
                        } else {
                            break;
                        }
                    }
                    
                    if (DEBUG) {System.out.print('\n');}
                    
                    // right up
                    if (DEBUG) {System.out.print(" RU>");}
                    int umax = (('h'-x) < (8-y)) ? ('h'-x) : (8-y);
                    for (int u = 1; u <= umax ; u++) {
                        if (isLegalMove(x+u,y+u,q,situation)) {
                            score = performThreatenTest(x+u,y+u,situation);
                            if (DEBUG) {System.out.print(score);}
                            if (score < bestScore) {
                                bestScore = score;
                                bestGame.clear();
                                bestGame.addAll(situation);
                                bestGame.add(new Queen(x+u,y+u));
                            }
                        } else {
                            break;
                        }
                    }
                    
                    // left up
                    if (DEBUG) {System.out.print(" LU>");}
                    umax = ((x-'a') < (8-y)) ? (x-'a') : (8-y);
                    for (int u = 1; u <= umax ; u++) {
                        if (isLegalMove(x-u,y+u,q,situation)) {
                            score = performThreatenTest(x-u,y+u,situation);
                            if (DEBUG) {System.out.print(score);}
                            if (score < bestScore) {
                                bestScore = score;
                                bestGame.clear();
                                bestGame.addAll(situation);
                                bestGame.add(new Queen(x-u,y+u));
                            }
                        } else {
                            break;
                        }
                    }
                    
                    // left down
                    if (DEBUG) {System.out.print(" LD>");}
                    umax = ((x-'a') < (y-1)) ? (x-'a') : (y-1);
                    for (int u = 1; u <= umax ; u++) {
                        if (isLegalMove(x-u,y-u,q,situation)) {
                            score = performThreatenTest(x-u,y-u,situation);
                            if (DEBUG) {System.out.print(score);}
                            if (score < bestScore) {
                                bestScore = score;
                                bestGame.clear();
                                bestGame.addAll(situation);
                                bestGame.add(new Queen(x-u,y-u));
                            }
                        } else {
                            break;
                        }
                    }
                    
                    // right down
                    if (DEBUG) {System.out.print(" RD>");}
                    umax = (('h'-x) < (y-1)) ? ('h'-x) : (y-1);
                    for (int u = 1; u <= umax ; u++) {
                        if (isLegalMove(x+u,y-u,q,situation)) {
                            score = performThreatenTest(x+u,y-u,situation);
                            if (DEBUG) {System.out.print(score);}
                            if (score < bestScore) {
                                bestScore = score;
                                bestGame.clear();
                                bestGame.addAll(situation);
                                bestGame.add(new Queen(x+u,y-u));
                            }
                        } else {
                            break;
                        }
                    }
                    if (DEBUG) { System.out.println(); }
                } //if queen qScore > 0
                
                
            } //queen select for cycle
            
            if (bestGame != null) {
                System.out.println("------------------");
                for (Iterator k = bestGame.iterator(); k.hasNext(); ) {
                    System.out.print((Queen) k.next());
                }
                System.out.println();
            }
            
            bestScore = 8;
            moveCounter++;
            //do the best move
            game.clear();
            game.addAll(bestGame);
        } //main while <> 0 loop
        System.out.println("Celkem kroku "+moveCounter);
    }
    
    /**
     * Zjistí zda na poli (x,y) nestojí dáma, která není uvedena ve vyjímce
     * pokud stojí vrátí false
     * jinak vrátí true (tedy pokud na daném poli stojí dáma except)
     */
    public static boolean isLegalMove(int x, int y, Queen except, ArrayList<Queen> game) {
        boolean result = true;
        Queen t;
        for(Iterator jt = game.iterator(); jt.hasNext(); ) {
            
            t = (Queen) jt.next();
            if (!except.equals(t)) {
                if ((x == t.getX()) && (y == t.getY())) {
                    result = false;
                    return false;
                }
            }
        }
        return result;
    }
    
    
    /**
     * Najde počet ohrožených dam v dané hře
     */
    public static int performThreatenTest(ArrayList<Queen> game) {
        int result = 0;
        
        for(Iterator jt = game.iterator(); jt.hasNext(); ) {
            Queen t;
            t = (Queen) jt.next();
            result += performThreatenTest(t.getX(),t.getY(),game);
        }
        return result;
    }
    
    /**
     * Najde počet ohrožených dam z dané pozice
     */
    public static int performThreatenTest(int x, int y, ArrayList<Queen> game) {
        int threatenCount = 0;
        boolean exitDirection;
        int hash;
        
        // left
        exitDirection = false;
        for (int xa = x+1; xa<'i' ;xa++) {
            hash = Queen.getHashCode(xa,y);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        // right
        exitDirection = false;
        for (int xa = x-1; xa>= 'a' ;xa--) { // 93 == 'a' - 1
            hash = Queen.getHashCode(xa,y);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        // up
        exitDirection = false;
        for (int ya = y+1; ya < 9 ;ya++) {
            hash = Queen.getHashCode(x,ya);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        // down
        exitDirection = false;
        for (int ya = y-1; ya > 0 ;ya--) {
            hash = Queen.getHashCode(x,ya);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        
        // right up
        exitDirection = false;
        int umax = (('h'-x) < (8-y)) ? ('h'-x) : (8-y);
        for (int u = 1; u <= umax ; u++) {
            hash = Queen.getHashCode(x+u,y+u);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        // left up
        exitDirection = false;
        umax = ((x-'a') < (8-y)) ? (x-'a') : (8-y);
        for (int u = 1; u <= umax ; u++) {
            hash = Queen.getHashCode(x-u,y+u);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        // left down
        exitDirection = false;
        umax = ((x-'a') < (y-1)) ? (x-'a') : (y-1);
        for (int u = 1; u <= umax ; u++) {
            hash = Queen.getHashCode(x-u,y-u);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        // right down
        exitDirection = false;
        umax = (('h'-x) < (y-1)) ? ('h'-x) : (y-1);
        for (int u = 1; u <= umax ; u++) {
            hash = Queen.getHashCode(x+u,y-u);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        
        return threatenCount;
    }
    
    public static ArrayList<Queen> cloneExcept(Queen except, ArrayList<Queen> game) {
        ArrayList<Queen> result = new ArrayList<Queen>();
        Queen actual;
        for(Iterator i = game.iterator(); i.hasNext(); ) {
            actual = (Queen) i.next();
            if (!actual.equals(except)) {
                result.add(actual);
            }
        }
        return result;
    }
}


